/**
 * @file Figure.cpp
 * @brief LN^XPgNX`
 * @author cherub
 */
#include "stdafx.h"
#include "Figure.h"

/**
 * @fn CFigure::CFigure(CJoint *root)
 * @brief qtRXgN^
 * @param root [in] [gm[hւ̃|C^
 */
CFigure::CFigure(CJoint *root)
{
	m_pRoot = root;
	ListingJoint(root);
}

/**
 * @fn CFigure::~CFigure(void)
 * @brief fXgN^
 */
CFigure::~CFigure(void)
{
	m_pRoot->Destroy();
}

/**
 * @fn void CFigure::ListingJoint(CJoint *root)
 * @brief XPg؍\̃m[hXg̍쐬
 * @param root [in] [gm[hւ̃|C^
 */
void CFigure::ListingJoint(CJoint *root)
{
	m_vecJoints.push_back(root);
	for (size_t i = 0; i < root->GetChildCount(); ++i)
	{
		ListingJoint(root->GetChild(i));
	}
}

/**
 * @fn size_t CFigure::GetJointCount() const
 * @brief ֐ߑ̎擾
 * @return ֐ߑ
 */
size_t CFigure::GetJointCount() const
{
	return m_vecJoints.size();
}

/**
 * @fn void CFigure::SetRootPosition(const D3DXVECTOR3 &pos)
 * @brief [gʒu̐ݒ
 * @param pos [in] ʒuxNg
 */
void CFigure::SetRootPosition(const D3DXVECTOR3 &pos)
{
	m_pRoot->SetPosition(pos);
}

/**
 * @fn D3DXVECTOR3 CFigure::GetRootPosition() const
 * @brief [gʒu̎擾
 * @return [gʒuxNg
 */
D3DXVECTOR3 CFigure::GetRootPosition() const
{
	return m_pRoot->GetPosition();
}

/**
 * @fn void CFigure::SetRootOrientation(const D3DXQUATERNION &rot)
 * @brief [g̐ݒ
 * @param rot [in] [gNH[^jI
 */
void CFigure::SetRootOrientation(const D3DXQUATERNION &rot)
{
	m_pRoot->SetRotation(rot);
}

/**
 * @fn D3DXQUATERNION CFigure::GetRootOrientation() const
 * @brief [g̎擾
 * @return [gNH[^jI
 */
D3DXQUATERNION CFigure::GetRootOrientation() const
{
	return m_pRoot->GetRotation();
}

/**
 * @fn void CFigure::SetJointRotation(size_t jid, const D3DXQUATERNION &rot)
 * @brief ֐߉]ʂ̐ݒ
 * @param jid [in] ֐߃CfNX
 * @param rot [in] ]NH[^jI
 */
void CFigure::SetJointRotation(size_t jid, const D3DXQUATERNION &rot)
{
	m_vecJoints[jid]->SetRotation(rot);
}

/**
 * @fn D3DXQUATERNION CFigure::GetJointRotation(size_t jid) const
 * @brief ֐߉]ʂ̎擾
 * @param jid [in] ֐߃CfNX
 * @return ]NH[^jI
 */
D3DXQUATERNION CFigure::GetJointRotation(size_t jid) const
{
	return m_vecJoints[jid]->GetRotation();
}

/**
 * @fn CJoint* CFigure::GetRoot()
 * @brief [gm[hւ̃|C^̎擾
 * @return [gm[hւ̃|C^
 */
CJoint* CFigure::GetRoot()
{
	return m_pRoot;
}

/**
 * @fn D3DXVECTOR3 CFigure::GetWorldPosition(size_t jid) const
 * @brief ֐߃m[h̃[hW̎擾
 * @param jid [in] ֐߃CfNX
 * @return ֐߃m[h̃[hWxNg
 */
D3DXVECTOR3 CFigure::GetWorldPosition(size_t jid) const
{
	D3DXVECTOR3 vTmp(0, 0, 0), vWorldPos(0, 0, 0);
	D3DXMATRIX mTrans;

	mTrans = m_vecJoints[jid]->GetOffsetMatrix();
	D3DXVec3TransformCoord(&vWorldPos, &vTmp, &mTrans);

	for (CJoint *pNode = m_vecJoints[jid]->GetParent();pNode != NULL;pNode = pNode->GetParent())
	{
		mTrans = pNode->GetTransformMatrix();
		vTmp = vWorldPos;
		D3DXVec3TransformCoord(&vWorldPos, &vTmp, &mTrans);
	}
	return vWorldPos;
}
