/**
 * @file Figure.h
 * @brief LN^XPgNX錾
 * @author cherub
 */
#ifndef HUMAN_FIGURE_CLASS_HEADER_FILE_
#define HUMAN_FIGURE_CLASS_HEADER_FILE_
#pragma once

#include "Joint.h"

/**
 * @class CFigure Figure.h
 * @brief LN^XPgNX
 * @author cherub
 */
class CFigure
{
//
// variables
private:
	//! [gm[h
	CJoint *m_pRoot;
	//! ֐߃m[hXg
	std::vector<CJoint*> m_vecJoints;

//
// constructor/destructor
public:
	// qtRXgN^
	CFigure(CJoint *root);
	// fXgN^
	virtual ~CFigure(void);

//
// internal operator
private:
	// XPg؍\̃m[hXg̍쐬
	void ListingJoint(CJoint *root);

//
// attributes
public:
	// ֐ߑ̎擾
	size_t GetJointCount() const;

//
// accessor
public:
	// [gʒu̐ݒ
	void SetRootPosition(const D3DXVECTOR3 &pos);
	// [gʒu̎擾
	D3DXVECTOR3 GetRootPosition() const;
	// [g̐ݒ
	void SetRootOrientation(const D3DXQUATERNION &rot);
	// [g̎擾
	D3DXQUATERNION GetRootOrientation() const;
	// ֐߉]ʂ̐ݒ
	void SetJointRotation(size_t jid, const D3DXQUATERNION &rot);
	// ֐߉]ʂ̎擾
	D3DXQUATERNION GetJointRotation(size_t jid) const;
	// [gm[hւ̃|C^̎擾
	CJoint* GetRoot();

//
// forward kinematics
public:
	// ֐߃m[h̃[hWxNg̎擾
	D3DXVECTOR3 GetWorldPosition(size_t jid) const;
};

#endif //HUMAN_FIGURE_CLASS_HEADER_FILE_
