/**
 * @file Joint.h
 * @brief ֐߃NX錾
 * @author cherub
 */
#ifndef HUMAN_JOINT_HEADER_
#define HUMAN_JOINT_HEADER_
#pragma once

#include <d3dx9math.h>
#include "TreeNode.h"

/**
 * @class CJoint Joint.h
 * @brief ֐߃NX
 * @author cherub
 */
class CJoint : public CTreeNode
{
//
// variables
private:
	//! m[hItZbg
	D3DXVECTOR3 m_vOffset;
	//! ֐߉]
	D3DXQUATERNION m_qRotation;
	//! ֐߈ʒu
	D3DXVECTOR3 m_vPosition;
	//! {[̏gXtH[iItZbgCXP[j
	D3DXMATRIX m_mInit;

//
// constructor/destructor
public:
	// qtRXgN^
	CJoint(const D3DXVECTOR3 &offset, const CJoint *parent);
	// fXgN^
	virtual ~CJoint();

//
// initializer
public:
	// ֐
	void Initialize(const D3DXVECTOR3 offset, const CJoint *parent);

//
// accessor
public:
	// {[̏gXtH[̎擾
	D3DXMATRIX GetInitialTransform() const;
	// ֐߃ItZbgxNg̐ݒ
	void SetOffset(const D3DXVECTOR3 &offset);
	/** 
	 * @fn D3DXVECTOR3 CJoint::GetOffset() const
	 * @brief ֐߃ItZbgxNg̎擾
	 * @return ItZbgxNg
	 */
	D3DXVECTOR3 GetOffset() const
		{
			return m_vOffset;
		}
	// ֐߃ItZbgs̎擾
	D3DXMATRIX GetOffsetMatrix() const;
	// ]NH[^jI̐ݒ
	void SetRotation(const D3DXQUATERNION &q);
	/**
	 * @fn D3DXQUATERNION CJoint::GetRotation() const
	 * @brief ]NH[^jI̎擾
	 * @return ]NH[^jI
	 */
	D3DXQUATERNION GetRotation() const
		{
			return m_qRotation;
		}
	// ]s̎擾
	D3DXMATRIX GetRotationMatrix() const;
	// ʒuxNg̐ݒ
	void SetPosition(const D3DXVECTOR3 &pos);
	/**
	 * @fn D3DXVECTOR3 CJoint::GetPosition() const
	 * @brief ʒuxNg̎擾
	 * @return ʒuxNg
	 */
	D3DXVECTOR3 GetPosition() const
		{
			return m_vPosition;
		}
	// ʒus̎擾
	D3DXMATRIX GetPositionMatrix() const;
	// gXtH[s̎擾
	D3DXMATRIX GetTransformMatrix() const;

//
// overrides
public:
	// m[h̔j
	void Destroy();
	/**
	 * @fn CJoint* CJoint::GetParent()
	 * @brief e֐߃m[h̎擾
	 * @return ֐߃m[hւ̃|C^
	 */
	CJoint* GetParent()
		{
			return static_cast<CJoint*>(CTreeNode::GetParent());
		}
	// em[h̐ݒ
	void SetParent(const CJoint *node);
	/**
	 * @fn CJoint* CJoint::GetChild(int jid)
	 * @brief q֐߃m[h̎擾
	 * @return ֐߃m[hւ̃|C^
	 */
	CJoint* GetChild(size_t jid)
		{
			return dynamic_cast<CJoint*>(CTreeNode::GetChild(jid));
		}
	// qm[h̒ǉ
	void AddChild(CJoint *node);
	/**
	 * @fn CJoint* CJoint::GetRoot()
	 * @brief [gm[h̎擾
	 * @return [gm[hւ̃|C^
	 */
	CJoint* GetRoot()
		{
			return dynamic_cast<CJoint*>(CTreeNode::GetRoot());
		}
};

#endif // HUMAN_JOINT_HEADER_
