// SceneView.cpp : CSceneView NX̎
//

#include "stdafx.h"
#include "SkeletonMFC.h"

#include "MainDoc.h"
#include "SceneView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CSceneView

IMPLEMENT_DYNCREATE(CSceneView, CView)

BEGIN_MESSAGE_MAP(CSceneView, CView)
	ON_MESSAGE(WM_USER_RENDER_SCENE, OnRenderScene)
	ON_WM_DESTROY()
	ON_WM_PAINT()
	ON_WM_SIZE()
	ON_WM_LBUTTONDOWN()
	ON_WM_RBUTTONDOWN()
	ON_WM_MBUTTONDOWN()
	ON_WM_MOUSEMOVE()
END_MESSAGE_MAP()

// CSceneView RXgNV/fXgNV

CSceneView::CSceneView()
{
	m_pD3D = NULL;
	m_pDeviceD3D = NULL;
	m_pEffect = NULL;

	m_hWorld = NULL;
	m_hWorldIT = NULL;
	m_hWorldViewProj = NULL;
	m_hEyePos = NULL;

	m_pvView[0].x = 4.0f;
	m_pvView[0].y = 0.0f;
	m_pvView[0].z = 0.0f;

	m_pvView[1].x = 0.0f;
	m_pvView[1].y = 0.0f;
	m_pvView[1].z = 0.0f;

	m_pvView[2].x = 0.0f;
	m_pvView[2].y = 1.0f;
	m_pvView[2].z = 0.0f;

	for (int i = 0;i < 3;i++)
		D3DXMatrixIdentity(&m_pmViewTrans[i]);

	m_pMeshSphere = NULL;
	m_pFigure = NULL;
	m_nActiveJoint = 0;
}

CSceneView::~CSceneView()
{
}

BOOL CSceneView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs C Window NX܂̓X^C
	//  CĂB

	return CView::PreCreateWindow(cs);
}

// CSceneView `

void CSceneView::OnDraw(CDC* /*pDC*/)
{
	CMainDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	// TODO: ̏ꏊɃlCeBu f[^p̕`R[hǉ܂B
}


// CSceneView ff

#ifdef _DEBUG
void CSceneView::AssertValid() const
{
	CView::AssertValid();
}

void CSceneView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CMainDoc* CSceneView::GetDocument() const // fobOȊÕo[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMainDoc)));
	return (CMainDoc*)m_pDocument;
}
#endif //_DEBUG


// CSceneView bZ[W nh

void CSceneView::OnInitialUpdate()
{
	CView::OnInitialUpdate();

	HRESULT hr;

	if (hr = InitDirectGraphics(), FAILED(hr))
	{
		MessageBox(DXGetErrorString9(hr));
		exit(hr);
	}

	if (hr = InitRenderState(), FAILED(hr))
	{
		MessageBox(DXGetErrorString9(hr));
		exit(hr);
	}

	if (hr = InitHLSL(), FAILED(hr))
	{
		MessageBox(DXGetErrorString9(hr));
		exit(hr);
	}

	CreateSkeleton();
	D3DXCreateSphere(m_pDeviceD3D, 0.5f, 10, 10, &m_pMeshSphere, NULL);
}

void CSceneView::OnDestroy()
{
	CView::OnDestroy();

	if (m_pFigure != NULL)
		delete m_pFigure;
	if (m_pMeshSphere != NULL)
		m_pMeshSphere->Release();
	if (m_pEffect != NULL)
		m_pEffect->Release();
	if (m_pDeviceD3D != NULL)
		m_pDeviceD3D->Release();
	if (m_pD3D != NULL)
		m_pD3D->Release();
}

void CSceneView::OnPaint()
{
	CPaintDC dc(this);

	SendMessage(WM_USER_RENDER_SCENE);
}

void CSceneView::OnSize(UINT nType, int cx, int cy)
{
	CView::OnSize(nType, cx, cy);

	if (m_pD3D == NULL)
		return;

	D3DDISPLAYMODE d3dDM;
	HRESULT hr;

	if (hr = m_pD3D->GetAdapterDisplayMode(D3DADAPTER_DEFAULT, &d3dDM), FAILED(hr))
		return;

	float fAspect = ((float)cx / (float)cy) * ((d3dDM.Height * 4.0f) / (d3dDM.Width * 3.0f));
	D3DXMatrixPerspectiveFovLH(&m_mProjection, D3DX_PI / 4.0f, fAspect, 1.0f, 100.0f);
}

HRESULT CSceneView::InitDirectGraphics(void)
{
	HRESULT hr;
	D3DDISPLAYMODE d3dDM;
	D3DPRESENT_PARAMETERS d3dPP;

	if (m_pD3D = Direct3DCreate9(D3D_SDK_VERSION), m_pD3D == NULL)
		return E_FAIL;

	if (hr = m_pD3D->GetAdapterDisplayMode(D3DADAPTER_DEFAULT, &d3dDM), FAILED(hr))
		return hr;

	ZeroMemory(&d3dPP, sizeof(d3dPP));
	d3dPP.Windowed = TRUE;
	d3dPP.BackBufferWidth = 640;
	d3dPP.BackBufferHeight = 480;
	d3dPP.SwapEffect = D3DSWAPEFFECT_DISCARD;
	d3dPP.BackBufferFormat = d3dDM.Format;
	d3dPP.EnableAutoDepthStencil = TRUE;
	d3dPP.AutoDepthStencilFormat = D3DFMT_D16;
	d3dPP.BackBufferCount = 1;
	d3dPP.Flags = D3DPRESENTFLAG_LOCKABLE_BACKBUFFER;

    if (hr = m_pD3D->CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, GetSafeHwnd(), D3DCREATE_HARDWARE_VERTEXPROCESSING, &d3dPP, &m_pDeviceD3D), FAILED(hr))
	{
		if (hr = m_pD3D->CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, GetSafeHwnd(), D3DCREATE_SOFTWARE_VERTEXPROCESSING, &d3dPP, &m_pDeviceD3D), FAILED(hr))
		{
			if (hr = m_pD3D->CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_REF, GetSafeHwnd(), D3DCREATE_SOFTWARE_VERTEXPROCESSING, &d3dPP, &m_pDeviceD3D), FAILED(hr))
			{
				return hr;
			}
		}
	}
	return S_OK;
}

HRESULT CSceneView::InitRenderState(void)
{
	HRESULT hr;
	D3DDISPLAYMODE d3dDM;
	D3DXVECTOR3 pvTmp[3];

	m_pDeviceD3D->SetRenderState(D3DRS_ZENABLE, D3DZB_TRUE);
	m_pDeviceD3D->SetRenderState(D3DRS_DITHERENABLE, FALSE);
	m_pDeviceD3D->SetRenderState(D3DRS_MULTISAMPLEANTIALIAS, FALSE);
	m_pDeviceD3D->SetRenderState(D3DRS_CULLMODE, D3DCULL_NONE);

	D3DVIEWPORT9 vp;
	if(hr = m_pDeviceD3D->GetViewport(&vp), FAILED(hr))
		return hr;

	if (hr = m_pD3D->GetAdapterDisplayMode(D3DADAPTER_DEFAULT, &d3dDM), FAILED(hr))
		return hr;

	float fAspect = ((float)vp.Width / (float)vp.Height) * ((d3dDM.Height * 4.0f) / (d3dDM.Width * 3.0f));
	D3DXMatrixPerspectiveFovLH(&m_mProjection, D3DX_PI / 4.0f, fAspect, 1.0f, 100.0f);

	for (int i = 0;i < 3;i++)
		D3DXVec3TransformCoord(&pvTmp[i], &m_pvView[i], &m_pmViewTrans[i]);
	D3DXMatrixLookAtLH(&m_mView, &pvTmp[0], &pvTmp[1], &pvTmp[2]);

	return hr;
}

HRESULT CSceneView::InitHLSL(void)
{
	HRESULT	hr;

	if (hr = D3DXCreateEffectFromFile(m_pDeviceD3D, "Skeleton.fx",
					NULL, NULL, 0, NULL, &m_pEffect, NULL), FAILED(hr))
		return hr;
	
	m_hTechPhong = m_pEffect->GetTechniqueByName("PhongShader");
	if (m_hTechPhong == NULL)
		return E_FAIL;

	if (m_hWorld = m_pEffect->GetParameterByName(NULL, "g_mWorld"), m_hWorld == NULL)
		return E_FAIL;
	if (m_hWorldIT = m_pEffect->GetParameterByName(NULL, "g_mWorldIT"), m_hWorldIT == NULL)
		return E_FAIL;
	if (m_hWorldViewProj = m_pEffect->GetParameterByName(NULL, "g_mWorldViewProj"), m_hWorldViewProj == NULL)
		return E_FAIL;
	if (m_hEyePos = m_pEffect->GetParameterByName(NULL, "g_vEyePos"), m_hEyePos == NULL)
		return E_FAIL;

	D3DXVECTOR4 vTmp(m_pvView->x, m_pvView->y, m_pvView->z, 1.0f);
	m_pEffect->SetVector(m_hEyePos, &vTmp);

	return hr;
}

void CSceneView::OnLButtonDown(UINT nFlags, CPoint point)
{
	m_pntDown = point;
	CView::OnLButtonDown(nFlags, point);
}

void CSceneView::OnRButtonDown(UINT nFlags, CPoint point)
{
	m_pntDown = point;
	CView::OnRButtonDown(nFlags, point);
}

void CSceneView::OnMButtonDown(UINT nFlags, CPoint point)
{
	m_pntDown = point;
	CView::OnMButtonDown(nFlags, point);
}

void CSceneView::OnMouseMove(UINT nFlags, CPoint point)
{
	D3DXMATRIX mTrans, mTmp;
	D3DXVECTOR3 pvTmp[3];
	D3DXQUATERNION qt;

	int dx = point.x - m_pntDown.x;
	int dy = point.y - m_pntDown.y;

	switch (nFlags)
	{
	case MK_LBUTTON:
		D3DXMatrixRotationY(&mTrans, (float)dx / 400.0f);
		mTrans *= *D3DXMatrixRotationZ(&mTmp, (float)dy / 400.0f);
		m_pmViewTrans[0] = mTrans * m_pmViewTrans[0];
		m_pmViewTrans[1] = mTrans * m_pmViewTrans[1];
		m_pmViewTrans[2] = mTrans * m_pmViewTrans[2];
		break;
	case MK_RBUTTON:
		D3DXMatrixTranslation(&mTrans, 0.0f, dy / 200.0f, -dx / 200.0f);
		m_pmViewTrans[0] = mTrans * m_pmViewTrans[0];
		m_pmViewTrans[1] = mTrans * m_pmViewTrans[1];
		break;
	case MK_MBUTTON:
		m_pvView[0].x += -dy / 200.0f;
		if (m_pvView[0].x < 0.1f)
			m_pvView[0].x = 0.1f;
		break;

	case MK_LBUTTON | MK_SHIFT:
		D3DXQuaternionRotationYawPitchRoll(&qt, (float)dy / 400.0f, 0, 0);
		m_pFigure->SetJointRotation(m_nActiveJoint, qt * m_pFigure->GetJointRotation(m_nActiveJoint));
		break;
	case MK_MBUTTON | MK_SHIFT:
		D3DXQuaternionRotationYawPitchRoll(&qt, 0, (float)dy / 400.0f, 0);
		m_pFigure->SetJointRotation(m_nActiveJoint, qt * m_pFigure->GetJointRotation(m_nActiveJoint));
		break;
	case MK_RBUTTON | MK_SHIFT:
		D3DXQuaternionRotationYawPitchRoll(&qt, 0, 0, (float)dy / 400.0f);
		m_pFigure->SetJointRotation(m_nActiveJoint, qt * m_pFigure->GetJointRotation(m_nActiveJoint));
		break;
	default:
		return;
	}

	for (int i = 0;i < 3;i++)
		D3DXVec3TransformCoord(&pvTmp[i], &m_pvView[i], &m_pmViewTrans[i]);
	D3DXMatrixLookAtLH(&m_mView, &pvTmp[0], &pvTmp[1], &pvTmp[2]);

	D3DXVECTOR4 vTmp(pvTmp->x, pvTmp->y, pvTmp->z, 1.0f);
	m_pEffect->SetVector(m_hEyePos, &vTmp);

	m_pntDown = point;

	SendMessage(WM_USER_RENDER_SCENE);

	CView::OnMouseMove(nFlags, point);
}

LRESULT CSceneView::OnRenderScene(WPARAM wPara, LPARAM lPara)
{
	HRESULT hr;
	m_pDeviceD3D->Clear(0, NULL, D3DCLEAR_TARGET|D3DCLEAR_ZBUFFER, D3DCOLOR_XRGB(60,60,200), 1.0f, 0);

	if (hr = m_pDeviceD3D->BeginScene(), FAILED(hr))
		return -1;

	DrawSkeleton();
	DrawJointMarker();

	if (hr = m_pDeviceD3D->EndScene(), FAILED(hr))
		return -1;

	hr = m_pDeviceD3D->Present(NULL, NULL, NULL, NULL);

	return 0;
}

HRESULT CSceneView::DrawMeshSub(const LPD3DXMESH pMesh, const D3DXMATRIX &mWorld) const
{
	HRESULT hr;
	unsigned int nNumPass;
	D3DXMATRIX mTmp;

	m_pEffect->SetMatrix(m_hWorld, &mWorld);
	D3DXMatrixInverse(&mTmp, NULL, &mWorld);
	D3DXMatrixTranspose(&mTmp, &mTmp);
	m_pEffect->SetMatrix(m_hWorldIT, &mTmp);

	mTmp = mWorld * m_mView * m_mProjection;
	m_pEffect->SetMatrix(m_hWorldViewProj, &mTmp);

	if (hr = m_pEffect->Begin(&nNumPass, 0), FAILED(hr))
		return hr;

	m_pEffect->BeginPass(0);
	pMesh->DrawSubset(0);
	m_pEffect->EndPass();

	m_pEffect->End();

	return S_OK;
}



void CSceneView::CreateSkeleton()
{
	D3DXVECTOR3 v;

	// root
	v.x = 0; v.y = 0; v.z = 0;
	CJoint *root = new CJoint(v, NULL);
	v.x = 0; v.y = 20.0f; v.z = 0.0f;
	CJoint *waist = new CJoint(v, root);	root->AddChild(waist);
	v.x = 0; v.y = 20.0f; v.z = 0.0f;
	CJoint *neck = new CJoint(v, waist);	waist->AddChild(neck);
	v.x = 0; v.y = 20.0f; v.z = 0.0f;
	CJoint *head = new CJoint(v, neck);		neck->AddChild(head);

	v.x = 0; v.y = 20.0f; v.z = 20.0f;
	CJoint *lshold = new CJoint(v, waist);	waist->AddChild(lshold);
	v.x = 0; v.y = 0.0f; v.z = 20.0f;
	CJoint *lelbow = new CJoint(v, lshold);	lshold->AddChild(lelbow);
	v.x = 0; v.y = 0.0f; v.z = 20.0f;
	CJoint *lwrist = new CJoint(v, lelbow);	lelbow->AddChild(lwrist);
	v.x = 0; v.y = 0.0f; v.z = 10.0f;
	CJoint *lhand = new CJoint(v, lwrist);	lwrist->AddChild(lhand);

	v.x = 0; v.y = 20.0f; v.z = -20.0f;
	CJoint *rshold = new CJoint(v, waist);	waist->AddChild(rshold);
	v.x = 0; v.y = 0.0f; v.z = -20.0f;
	CJoint *relbow = new CJoint(v, rshold);	rshold->AddChild(relbow);
	v.x = 0; v.y = 0.0f; v.z = -20.0f;
	CJoint *rwrist = new CJoint(v, relbow);	relbow->AddChild(rwrist);
	v.x = 0; v.y = 0.0f; v.z = -10.0f;
	CJoint *rhand = new CJoint(v, rwrist);	rwrist->AddChild(rhand);

	v.x = 0; v.y = -10.0f; v.z = 10.0f;
	CJoint *lhip = new CJoint(v, root);		root->AddChild(lhip);
	v.x = 0; v.y = -30.0f; v.z = 0.0f;
	CJoint *lknee = new CJoint(v, lhip);	lhip->AddChild(lknee);
	v.x = 0; v.y = -30.0f; v.z = 0.0f;
	CJoint *lankle = new CJoint(v, lknee);	lknee->AddChild(lankle);
	v.x = 20.0f; v.y = 0.0f; v.z = 0.0f;
	CJoint *lfoot = new CJoint(v, lankle);	lankle->AddChild(lfoot);

	v.x = 0; v.y = -10.0f; v.z = -10.0f;
	CJoint *rhip = new CJoint(v, root);		root->AddChild(rhip);
	v.x = 0; v.y = -30.0f; v.z = 0.0f;
	CJoint *rknee = new CJoint(v, rhip);	rhip->AddChild(rknee);
	v.x = 0; v.y = -30.0f; v.z = 0.0f;
	CJoint *rankle = new CJoint(v, rknee);	rknee->AddChild(rankle);
	v.x = 20.0f; v.y = 0.0f; v.z = 0.0f;
	CJoint *rfoot = new CJoint(v, rankle);	rankle->AddChild(rfoot);

	m_pFigure = new CFigure(root);
}

void CSceneView::DrawSkeletonSub(CJoint *pJoint, LPD3DXMATRIXSTACK &pMatStack)
{
	if (pJoint == NULL)
		return;
	
	pMatStack->Push();
	pMatStack->MultMatrixLocal(&pJoint->GetInitialTransform());
		DrawMeshSub(m_pMeshSphere, *pMatStack->GetTop());
	pMatStack->Pop();

	pMatStack->Push();
		pMatStack->MultMatrixLocal(&pJoint->GetTransformMatrix());
		for (size_t j = 0;j < pJoint->GetChildCount();j++)
			DrawSkeletonSub(pJoint->GetChild(j), pMatStack);
	pMatStack->Pop();
}

void CSceneView::DrawSkeleton()
{
	HRESULT hr;
	LPD3DXMATRIXSTACK pMatStack;
	CJoint *pRoot;

	if (hr = D3DXCreateMatrixStack(0, &pMatStack), FAILED(hr))
		return;

	m_pEffect->SetTechnique("PhongShader");
	m_pEffect->SetVector("g_vAmbiColor", &D3DXVECTOR4(0.6f, 0.6f, 0.6f, 1.0f));
	m_pEffect->SetVector("g_vSurfColor", &D3DXVECTOR4(0.6f, 0.6f, 0.6f, 1.0f));

	pMatStack->LoadIdentity();
	pMatStack->Scale(0.02f, 0.02f, 0.02f);

	pMatStack->Push();
		pRoot = m_pFigure->GetRoot();
		pMatStack->Push();
			pMatStack->MultMatrixLocal(&pRoot->GetTransformMatrix());
			for (size_t j = 0;j < pRoot->GetChildCount();j++)
				DrawSkeletonSub(pRoot->GetChild(j), pMatStack);
		pMatStack->Pop();
	pMatStack->Pop();

	pMatStack->Release();
}

void CSceneView::DrawJointMarker()
{
	D3DXVECTOR3 pos = m_pFigure->GetWorldPosition(m_nActiveJoint);
	D3DXMATRIX world, tmp;
	D3DXMatrixScaling(&world, 0.02f, 0.02f, 0.02f);
	D3DXMatrixTranslation(&tmp, pos.x, pos.y, pos.z);
	world = tmp * world;
	D3DXMatrixScaling(&tmp, 5.0f, 5.0f, 5.0f);
	world = tmp * world;

	m_pEffect->SetTechnique("PhongShader");
	m_pEffect->SetVector("g_vAmbiColor", &D3DXVECTOR4(1.0f, 0.2f, 0.2f, 1.0f));
	m_pEffect->SetVector("g_vSurfColor", &D3DXVECTOR4(1.0f, 0.2f, 0.2f, 1.0f));

	DrawMeshSub(m_pMeshSphere, world);
}

void CSceneView::SelectJoint(size_t joint)
{
	m_nActiveJoint = joint;
}
